/*
	(c)Copyright	All rights reserved.
		K.Masuda	2014.01.16
			< Index.c >
*/
/*
	(c)Copyright	All rights reserved.
		K.Masuda	2016.01.18
					2019.02.17
	   k.masuda.52431@gmailcom
	  Cell phone : 080-5444-1937

	203 NIC Heim Akabane, 22-31
	Iwabuchi-machi, Kita-ku Tokyo
			Japan	115-0041

	503 Grand Maison Nishi-sugamo
	1-14-3 Nishi-sugamo, Toshima-ku
		Tokyo, Japan 170-0001
	  Fax, phone : 03-5394-3324

		and Shirhill family
		and Apple & Microsoft
			  and Bell.
*/
/*
	(c)Copyright	All rights reserved.
               <<CryptOneX>>
            K.Masuda & Shirhill
             Apple & Microsoft
                 Borland
               Oracle & IBM
             Bell & BSD & MIT
                  NORAD.

                 2020.04
                 2022.03
*/

#include	"Area.h"
#include	"Color.h"
#include	"MyTrace.h"

#define	RGNMAX		( ELEVEN )
#define	MAXBUFSZ2	( MAXBUFSZ * 2 )

typedef	struct	_Index_	{
		int		iNo;
		char	*pcCntry;
		char	*pcRgn;
	}	t_Index;

typedef	struct	_Region_	{
		t_Index	pstBase[ ELEVEN ];
}	t_Region;

static	t_Region	stRegion;
static	char		pcBuf[ ELEVEN + 1 ][ 60 ];
static	char		pcLBuf[ MAXBUFSZ2 ];
static	char		pcMsg[ 256 ];

int		main(
int		iArgc,
char	*pcArgv[]
){
	int			iLp1, iLp2;
	int			iLp1Max;
	void		*pvRtn;
	char		*pcTmp;
	FILE		*pstFid;

	if( iArgc < 2 ){
		printf( "./Index <Rgn file>\n" );
		exit( 1 );
	}

	_TRC_INIT( "GenIndex" );
	_TRC_ENTR( "main" );

	pstFid = FOpen( pcArgv[ 1 ], "r" );
	if( pstFid == NULL ){
		printf( "Error : File name illegal. : %s\n", strerror( errno ) );
		exit( 1 );
	}
	memset( pcBuf, 0x00, ( ELEVEN + 1 ) * 60 );
	memset( &stRegion, 0x00, sizeof( t_Region ) );

	for( iLp1 = 0;; iLp1 ++ ){
		_TRC_DMPD( "-->iLp1", iLp1 );
		pvRtn = fgets( pcBuf[ iLp1 ], MAXBUFSZ2, pstFid );
		_NOTRC_DUMP( strerror( errno ) );
#if	1
		if( pvRtn == NULL ){
			sprintf( pcMsg, "Error : fgets(%s,,) : %s",
								pcBuf[ iLp1 ], strerror( errno ) );
			_TRC_DUMP( pcMsg );
			break;
		}
#endif
		pcBuf[ iLp1 ][ strlen( pcBuf[ iLp1 ] ) - 1 ] = 0x00;
		_TRC_DMPS( "pcBuf", pcBuf[ iLp1 ] );
		/* 国番号 */
		pcTmp = strchr( pcBuf[ iLp1 ], ',' );	
		*pcTmp = 0x00;
		_TRC_DMPS( "iNo", pcBuf[ iLp1 ] );
		stRegion.pstBase[ iLp1 ].iNo = atoi( pcBuf[ iLp1 ] );
		_TRC_DMPD( "CntryNo", stRegion.pstBase[ iLp1 ].iNo );

		/* 国名 */
		pcTmp ++;
		stRegion.pstBase[ iLp1 ].pcCntry = pcTmp;
		_TRC_DMPS( "pcCntry", stRegion.pstBase[ iLp1 ].pcCntry );

		pcTmp = strchr( pcTmp, ',' );	
		*pcTmp = 0x00;
		/* 地域名 */
		pcTmp ++;
		stRegion.pstBase[ iLp1 ].pcRgn = pcTmp;
		_TRC_DMPS( "pcRgn", stRegion.pstBase[ iLp1 ].pcRgn );
	}
	_TRC_DUMP( "End of initialize" );
	iLp1Max = iLp1;

	/* 隣接国名の出力 */
	for( iLp1 = 0; iLp1 < iLp1Max; iLp1 ++ ){	
		printf( "-----\n%s : %s : %d\n-----\n",
				stRegion.pstBase[ Area[ iLp1 ].id ].pcRgn,
				stRegion.pstBase[ Area[ iLp1 ].id ].pcCntry,
				Area[ iLp1 ].no );
		for( iLp2 = 0; iLp2 < Area[ iLp1 ].no; iLp2 ++ ){
			printf( "%3d : %32s : %16s\n",
					iLp2,
					stRegion.pstBase[ Area[ iLp1 ].neib[ iLp2 ] ].pcCntry,
					stRegion.pstBase[ Area[ iLp1 ].neib[ iLp2 ] ].pcRgn );
		}
		printf( "-----\n" );
	}
	FClose( pstFid );

	_TRC_EXIT();
	_TRC_TERM();
}
