/*
	(c)Copyright	All rights reserved.
		K.Masuda	2024.01.19
			< Rslt.c >
*/


/*
	(c)Copyright	All rights reserved.
               <<CryptOneX>>
            K.Masuda & Shirhill
             Apple & Microsoft
                 Borland
               Oracle & IBM
             Bell & BSD & MIT
                  NORAD.

                 2020.04
                 2022.03
*/

#include	"Color.h"
#include	"Area.h"
#include	"MyTrace.h"

#define	RGNMAX		( ELEVEN )
#define	MAXBUFSZ2	( MAXBUFSZ * 2 )

typedef	struct	_Index_	{
		int		iNo;
		char	*pcCntry;
		char	*pcRgn;
	}	t_Index;

typedef	struct	_Region_	{
		t_Index	pstBase[ ELEVEN ];
}	t_Region;

static	t_Region	stRegion;
static	char		pcBuf[ ELEVEN + 1 ][ 60 ];
static	char		pcLBuf[ MAXBUFSZ2 ];
static	char		pcMsg[ 256 ];

int		main(
int		iArgc,
char	*pcArgv[]
){
	int			iLp1, iCnt;
	int			iLp1Max;
	void		*pvRtn;
	char		*pcTmp;
	FILE		*pstFid;

	if( iArgc < 3 ){
		printf( "./Rslt <Rgn file> <Tmp.dat file>\n" );
		exit( 1 );
	}

	_TRC_INIT( "Rslt" );
	_TRC_ENTR( "main" );

	pstFid = FOpen( pcArgv[ 1 ], "r" );
	if( pstFid == NULL ){
		printf( "Error : File name illegal. : %s\n", strerror( errno ) );
		exit( 1 );
	}
	memset( pcBuf, 0x00, ( ELEVEN + 1 ) * 60 );
	memset( &stRegion, 0x00, sizeof( t_Region ) );

	for( iLp1 = 0; iLp1 < RGNMAX; iLp1 ++ ){
		_TRC_DMPD( "-->iLp1", iLp1 );
		pvRtn = fgets( pcBuf[ iLp1 ], MAXBUFSZ2, pstFid );
		_NOTRC_DUMP( strerror( errno ) );
#if	1
		if( pvRtn == NULL ){
			sprintf( pcMsg, "Error : fgets(%s,,) : %s",
								pcBuf[ iLp1 ], strerror( errno ) );
			_TRC_DUMP( pcMsg );
			break;
		}
#endif
		pcBuf[ iLp1 ][ strlen( pcBuf[ iLp1 ] ) - 1 ] = 0x00;
		_TRC_DMPS( "pcBuf", pcBuf[ iLp1 ] );
		/* 国番号 */
		pcTmp = strchr( pcBuf[ iLp1 ], ',' );	
		*pcTmp = 0x00;
		_TRC_DMPS( "iNo", pcBuf[ iLp1 ] );
		stRegion.pstBase[ iLp1 ].iNo = atoi( pcBuf[ iLp1 ] );
		_TRC_DMPD( "CntryNo", stRegion.pstBase[ iLp1 ].iNo );

		/* 国名 */
		pcTmp ++;
		stRegion.pstBase[ iLp1 ].pcCntry = pcTmp;
		_TRC_DMPS( "pcCntry", stRegion.pstBase[ iLp1 ].pcCntry );

		pcTmp = strchr( pcTmp, ',' );	
		*pcTmp = 0x00;
		/* 地域名 */
		pcTmp ++;
		stRegion.pstBase[ iLp1 ].pcRgn = pcTmp;
		_TRC_DMPS( "pcRgn", stRegion.pstBase[ iLp1 ].pcRgn );
		pcBuf[ iLp1 + 1 ][ 0 ] = 0x00;
	}
	FClose( pstFid );
	_TRC_DUMP( "End of initialize" );
	_TRC_DMPD( "iLp1Max", iLp1 );
	iLp1Max = iLp1;

	/* 国名、色番号の出力 */
	_TRC_DMPS( "pcArgv[2]", pcArgv[ 2 ] );
	pstFid = FOpen( pcArgv[ 2 ], "r" );
	if( pstFid == NULL ){
		printf( "Error : File name illegal. : %s\n", strerror( errno ) );
		exit( 1 );
	}
	iCnt = 0;
	while( ( pvRtn = fgets( pcLBuf, MAXBUFSZ2, pstFid ) ) != NULL ){
		pcLBuf[ strlen( pcLBuf ) - 1 ] = 0x00;
		printf( "----- %d -----\n", iCnt );
		_TRC_DMPS( "pcLBuf", pcLBuf );
		for( iLp1 = 0; iLp1 < iLp1Max; iLp1 ++ ){
			printf( "%16s : %32s : %2d\n",
					stRegion.pstBase[ iLp1 ].pcRgn,
					stRegion.pstBase[ iLp1 ].pcCntry,
					ATOI4( pcLBuf, iLp1 + 1 ) );
		}
		printf( "^^^^^ %d ^^^^^\n", iCnt );
		iCnt ++;
	}
	FClose( pstFid );
	
	_TRC_EXIT();
	_TRC_TERM();
	exit( 0 );
}
