/*
	(c)Copyright	All rights reserved.
		K.Masuda	2021.04.03
			< Area.h >
*/
/*
	(c)Copyright	All rights reserved.
		K.Masuda	2016.01.18
					2019.02.17

		These materials inherit <<CryptOne>>

		and Shirhill family
		and Apple & Microsoft
			  and Bell.
*/
/*
	(c)Copyright	All rights reserved.
               <<CryptOneX>>

		These materials inherit <<CryptOne>>

            K.Masuda & Shirhill
             Apple & Microsoft
                 Borland
               Oracle & IBM
             Bell & BSD & MIT
                  NORAD.

                 2020.04
                 2022.03
*/

#ifndef	_AREA_H_
#define	_AREA_H_

#include	"Color.h"	/* ELEVEN は、このヘッダに定義あり */

/*
	初期の Area.h の Area 値は１１カ国のデータとなっている。
	縦に国番号、横の −１ は変更の必要なし、隣接国番号のリスト（固定で最大
	２５６カ国）となっています。

	Color.hのマクロ変数 ELEVEN の値は色分けする国数で最大２５５まで
	設定できるでしょう。Area 変数の初期値（定数）と合わせて修正、コンパイル
	して下さい。その際には makefile.11, makefile.15, makefile.16 をご利用に
	なると便利です。



	著作者より、。

	2021.12.29	K.Masuda
*/

#ifdef	CNTRY2
static	color_t		Area[ ELEVEN ] = {
			/*   国番号,色の初期値,隣接国番号リスト */
				{ 0,            -1, 1, 1, 0 },
				{ 1,            -1, 1, 0, 0 }
			};
#else
#ifdef	CNTRY3
static	color_t		Area[ ELEVEN ] = {
			/*   国番号,色の初期値,隣接国番号リスト */
				{ 0,            -1, 2, 1, 2, 0 },
				{ 1,            -1, 2, 2, 0, 0 },
				{ 2,            -1, 2, 0, 1, 0 }
			};
#else
#ifdef	CNTRY5
static	color_t		Area[ ELEVEN ] = {
			/*   国番号,色の初期値,隣接国番号リスト */
				{ 0,            -1, 2, 1, 2, 0, 0, 0 },
				{ 1,            -1, 4, 0, 2, 3, 4, 0 },
				{ 2,            -1, 4, 0, 1, 3, 4, 0 },
				{ 3,            -1, 3, 1, 2, 4, 0, 0 },
				{ 4,            -1, 3, 1, 2, 3, 0, 0 }
			};
#else
#ifdef	CNTRY7
static	color_t		Area[ ELEVEN ] = {
			/*   国番号,色の初期値,隣接国番号リスト */
				{ 0,            -1, 2, 1, 2, 0, 0, 0, 0, 0 },
				{ 1,            -1, 4, 0, 2, 3, 4, 0, 0, 0 },
				{ 2,            -1, 4, 0, 1, 3, 4, 0, 0, 0 },
				{ 3,            -1, 5, 1, 2, 4, 5, 6, 0, 0 },
				{ 4,            -1, 5, 1, 2, 3, 5, 6, 0, 0 },
				{ 5,            -1, 3, 3, 4, 6, 0, 0, 0, 0 },
				{ 6,            -1, 3, 3, 4, 5, 0, 0, 0, 0 }
			};
#else
#ifdef	CNTRY11
static	color_t		Area[ ELEVEN ] = {
			/*   国番号,色の初期値,隣接国番号リスト */
				{ 0,			-1, 7, 1, 2, 3, 4, 5, 6, 7, 0, 0, 0, 0 },
				{ 1,			-1, 4, 0, 2, 3, 7, 0, 0, 0, 0, 0, 0, 0 },
				{ 2,			-1, 5, 0, 1, 3, 8, 9, 0, 0, 0, 0, 0, 0 },
				{ 3,			-1, 4, 0, 2, 4, 9, 0, 0, 0, 0, 0, 0, 0 },
				{ 4,			-1, 5, 0, 3, 5, 9,10, 0, 0, 0, 0, 0, 0 },
				{ 5,			-1, 4, 0, 4, 6,10, 0, 0, 0, 0, 0, 0, 0 },
				{ 6,			-1, 5, 0, 5, 7, 8,10, 0, 0, 0, 0, 0, 0 },
				{ 7,			-1, 4, 0, 1, 6, 8, 0, 0, 0, 0, 0, 0, 0 },
				{ 8,			-1, 5, 1, 2, 7, 9,10, 0, 0, 0, 0, 0, 0 },
				{ 9,			-1, 5, 2, 3, 4, 8,10, 0, 0, 0, 0, 0, 0 },
				{10,			-1, 5, 4, 5, 6, 8, 9, 0, 0, 0, 0, 0, 0 }
			};
#else
#ifdef	CNTRY15
static	color_t		Area[ ELEVEN ] = {
			/*   国番号,色の初期値,隣接国番号リスト */
				{ 0,			-1, 4, 1, 2, 3, 4, 0, 0, 0, 0, 0, 0, 0 },
				{ 1,			-1, 5, 0, 2, 4, 5, 8, 0, 0, 0, 0, 0, 0 },
				{ 2,			-1, 6, 0, 1, 3, 5, 6, 7, 0, 0, 0, 0, 0 },
				{ 3,			-1, 4, 0, 2, 4, 7, 0, 0, 0, 0, 0, 0, 0 },
				{ 4,			-1, 5, 0, 1, 3, 7, 8, 0, 0, 0, 0, 0, 0 },
				{ 5,			-1, 5, 1, 2, 9,13,14, 0, 0, 0, 0, 0, 0 },
				{ 6,			-1, 4, 2, 5, 7, 9, 0, 0, 0, 0, 0, 0, 0 },
				{ 7,			-1, 8, 2, 3, 4, 6, 8, 9,10,11, 0, 0, 0 },
				{ 8,			-1, 7, 1, 4, 5, 7,11,12,13, 0, 0, 0, 0 },
				{ 9,			-1, 4, 6, 7,10,14, 0, 0, 0, 0, 0, 0, 0 },
				{10,			-1, 3, 7, 9,11, 0, 0, 0, 0, 0, 0, 0, 0 },
				{11,			-1, 4, 7, 8,10,12, 0, 0, 0, 0, 0, 0, 0 },
				{12,			-1, 3, 8,11,13, 0, 0, 0, 0, 0, 0, 0, 0 },
				{13,			-1, 4, 5, 8,12,14, 0, 0, 0, 0, 0, 0, 0 },
				{14,			-1, 3, 5, 9,13, 0, 0, 0, 0, 0, 0, 0, 0 }
			};
#else
#ifdef	CNTRY16
static	color_t		Area[ ELEVEN ] = {
			/*   国番号,色の初期値,隣接国番号リスト */
				{ 0,			-1, 4, 1, 2, 3, 4, 0, 0, 0, 0, 0, 0, 0 },
				{ 1,			-1, 5, 0, 2, 4, 5, 8, 0, 0, 0, 0, 0, 0 },
				{ 2,			-1, 6, 0, 1, 3, 5, 6, 7, 0, 0, 0, 0, 0 },
				{ 3,			-1, 4, 0, 2, 4, 7, 0, 0, 0, 0, 0, 0, 0 },
				{ 4,			-1, 5, 0, 1, 3, 7, 8, 0, 0, 0, 0, 0, 0 },
				{ 5,			-1, 5, 1, 2, 9,13,14, 0, 0, 0, 0, 0, 0 },
				{ 6,			-1, 4, 2, 5, 7, 9, 0, 0, 0, 0, 0, 0, 0 },
				{ 7,			-1, 8, 2, 3, 4, 6, 8, 9,10,11, 0, 0, 0 },
				{ 8,			-1, 7, 1, 4, 5, 7,11,12,13, 0, 0, 0, 0 },
				{ 9,			-1, 4, 6, 7,10,14, 0, 0, 0, 0, 0, 0, 0 },
				{10,			-1, 3, 7, 9,11, 0, 0, 0, 0, 0, 0, 0, 0 },
				{11,			-1, 4, 7, 8,10,12, 0, 0, 0, 0, 0, 0, 0 },
				{12,			-1, 3, 8,11,13, 0, 0, 0, 0, 0, 0, 0, 0 },
				{13,			-1, 4, 5, 8,12,14, 0, 0, 0, 0, 0, 0, 0 },
				{14,			-1, 3, 5, 9,13, 0, 0, 0, 0, 0, 0, 0, 0 },
				{15,			-1, 6, 9,10,11,12,13,14, 0, 0, 0, 0, 0 }
			};
#else
#ifdef	CNTRY199

static	color_t		Area[ ELEVEN ] = {

#include	"Area.h.org.199"

			};
#else
#ifdef	CNTRY55

static	color_t		Area[ ELEVEN ] = {

#include	"Area.h.org.55"

			};
#else
#ifdef	CNTRY51

static	color_t		Area[ ELEVEN ] = {

#include	"Area.h.org.51"

			};
#else
#ifdef	CNTRY46

static	color_t		Area[ ELEVEN ] = {

#include	"Area.h.org.46"

			};
#else
#ifdef	CNTRY36

static	color_t		Area[ ELEVEN ] = {

#include	"Area.h.org.36"

		};

#else
#ifdef	CNTRY24

static	color_t		Area[ ELEVEN ] = {

#include	"Area.h.org.24"

		};
#else
#ifdef	CNTRY14

static	color_t		Area[ ELEVEN ] = {

#include	"Area.h.org.14"

		};
#else
#ifdef	CNTRY13

static	color_t		Area[ ELEVEN ] = {

#include	"Area.h.org.13"

		};
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif

#endif
