/*
	(c)Copyright	All rights reserved.
		K.Masuda	2021.12.30
		and Shirhill family.
			< Color2Sub.c >

		These materials inherit <<CryptOne>>
*/
/*
	(c)Copyright	All rights reserved.
		K.Masuda	2016.01.18
					2019.02.17

		and Shirhill family
		and Apple & Microsoft
			  and Bell.
*/
/*
	(c)Copyright	All rights reserved.
               <<CryptOneX>>

            K.Masuda & Shirhill
             Apple & Microsoft
                 Borland
               Oracle & IBM
             Bell & BSD & MIT
                  NORAD.

                 2020.04
                 2022.03
*/

/*
#define		DEBUG
*/
#ifdef	DEBUG
static	int		iLoop1;
static	long	lPass[ 2 ]	= { 0, 0 };
#endif

#include	"Color.h"
#include	"MyTrace.h"

static	int		iStat[ ELEVEN ][ MAXSTAT ];
static	int		piIntr[ ELEVEN ];
static	int		iSz;
static	FILE	*pstFid;
static	char	pcMsg[ 256 ];

extern	int		*Sort1( int, int * );

static	int		NeighClrLst( color_t *, int, int, int *, int );
extern	int		NeiChk( color_t *, int );
static	int		genCsc( int, int *, int *, int );
static	int		Match( int *, int, int *, int, int * );
static	void	piHighVal( int *, int );

/*
	４色問題の解法メイン関数
*/
void		rslv(
color_t		*area,
int			eleven,
int			iDepth,
int			iColor,
int			maxclr
){
	int		iLp1, iRtn, iTmp;
	int		piNxtClr[ maxclr ];

	_TRC_ENTR( "rslv" );
	_NOTRC_DMPD( "eleven", eleven );
	_NOTRC_DMPD( "rslv()の入口、引数の:iDepth", iDepth );
	_NOTRC_DMPD( "iColor", iColor );

	/* ４色以下の利用で現在国が１１番目以内なら４色問題解法を続ける */
	/* iColor は現在国の色番号 */
	setAllSt( iDepth, iColor, CLR2_INIT, area );	/*色, 初期状態*/
	_NOTRC_DUMP( "rslv() の最初から、次は L1:; while(1){ に続く" );
	iDepth ++;
	_NOTRC_DMPD( "現在の深さ、インクリメント後:iDepth", iDepth );

#if	0
if( iDepth == 6 ){
	sleep( 100 );
}
#endif
	/* ----------------- K.Masuda : 2022.02.16 ---------------- */
	_NOTRC_DMPD( "現在の深さ:iDepth", iDepth );
	/* 最後の国まで検査終了なら結果を出力 */
	if( iDepth == eleven ){
		Print( area, iDepth );
		iDepth --;
		_NOTRC_DUMP( "----- 調査中 -----" );
		setAllSt( iDepth, -1, CLR2_INIT, area );

		_TRC_EXIT();
		return;
	}
L0:;
	_TRC_DMPD( "while(){の先頭::iDepth", iDepth );
	_NOTRC_DMPD( "現在国番号", getStat( iDepth, ID ) );

	/* 隣接国との色干渉を調べる */
	if( ( iRtn = Neigh( area, eleven, iDepth, piNxtClr, maxclr ) ) < 0 ){
		/* 干渉している、近隣国色が邪魔で先に進めない */
		/* 現状では色が選べない */
		iDepth --;
		_NOTRC_DUMP( "----- 調査中 -----" );
		setAllSt( iDepth, -1, CLR2_INIT, area );

		_TRC_EXIT();
		return;
	}
	else if( iRtn == 0 ){
		/* 選べる色番号が存在しない、戻る */
		iDepth --;;
		_NOTRC_DUMP( "----- 調査中 -----" );
		setAllSt( iDepth, -1, CLR2_INIT, area );

		_TRC_EXIT();
		return;
	}
	/* ---------- K.Masuda : 2022.02.18 -------------- */
	_NOTRC_DUMP( "次のネストに移動、新たな国の色決めを行う" );
	/* iColor は次の現在ネストレベルの国の色(初期値==0)に変更し、 */
	/* 0..3.. の色について rslv() を呼出す */
	_NOTRC_DMPD( "iRtn", iRtn );
#ifdef	DEBUG
	sprintf( pcMsg, "iRtn:選択可能色数=%d", iRtn );
	_TRC_DUMP( pcMsg );
	for( iLp1 = 0; iLp1 < iRtn; iLp1 ++ ){
		sprintf( pcMsg, "選択可能色:piNxtClr[%d]=%d",
										iLp1, piNxtClr[ iLp1 ] );
		_TRC_DUMP( pcMsg );
	}
#endif
	for( iLp1 = 0; iLp1 < iRtn; iLp1 ++ ){
		iColor = piNxtClr[ iLp1 ];
		_TRC_DMPD( "iColor(<maxclr)", iColor );
		/* 次国の色決定を行う */
		_NOTRC_DUMP( "--------------------" );
		_NOTRC_DMPD( "for(;;){ rslv() の引数::現在の深さ:iDepth",
														iDepth );
		_NOTRC_DMPD( "for(;;){ rslv() の引数::次の色:iColor", iColor );
		/* ネスとレベルを上げ色干渉、色数を再度検査する */
		/* ネスとレベルを上げ色干渉、色数を再度検査する */
		rslv( area, eleven, iDepth, iColor, maxclr );
		/* 実現可能職を全て試し終わったら */
		/* 呼出レベルのデクリメント */
	}
	/* このレベルの処理は終了 */
	iDepth --;
	_NOTRC_DUMP( "----- 調査中 -----" );
	setAllSt( iDepth, -1, CLR2_INIT, area );
	_TRC_EXIT();
	return;
}

static	int		NeighClrLst(
color_t	*area,
int		eleven,
int		iDepth,
int		*piNxtClr,
int		maxclr
){
	int		iLp1, iTmp, iTmp1;
	int		piInNeigh[ ELEVEN ], piOtNeigh[ ELEVEN ];
	int		piInStat[ ELEVEN ], piOtStat[ ELEVEN ];
	int		piColor[ ELEVEN ], piOtColor[ ELEVEN ];
	int		*piOtData;
	int		iIntrNo;

	_NOTRC_ENTR( "NeighClrLst" );

	/* 変数の初期化 */
	piHighVal( piInNeigh, ELEVEN );
	piHighVal( piOtNeigh, ELEVEN );
	piHighVal( piInStat, ELEVEN );
	piHighVal( piOtStat, ELEVEN );

	/* 隣接国に無い色リスト piCscTbl を作る */
	_NOTRC_DUMP( "隣接国に無い色リスト piCscTbl を作る" );

	/* iDepth 以下の隣接国色のソート用データ piColor を生成 */
	/* 先ずは piColor の HighVal クリア */
	piHighVal( piColor, ELEVEN );
	piHighVal( piOtColor, ELEVEN );

	/* 隣接国を纏める */
	iTmp = getStat( iDepth, ID );	/* 現在国番号 */
	_NOTRC_DMPD( "iDepth:現在国のネストレベル", iDepth );
	_NOTRC_DMPD( "iTmp(ID):現在国番号", iTmp );
		/* 現在国の隣接国のソート準備、piInNeigh に原始データをセット */
		iTmp1 = area[ iTmp ].no;	/* 隣接国の数 */
		_NOTRC_DMPD( "iTmp1(area[iTmp].no,<ELEVEN):隣接国数", iTmp1 );
		for( iLp1 = 0; iLp1 < iTmp1; iLp1 ++ ){
			/* 現在国の原始隣接国番号を設定する */
			piInNeigh[ iLp1 ] = area[ iTmp ].neib[ iLp1 ];
			_NOTRC_DMPD( "area[iTmp].neib[0..iTmp1]",
										area[ iTmp ].neib[ iLp1 ] );
		}

	/* 隣接国に無い色リスト piCscTbl を作る */
	_NOTRC_DUMP( "隣接国(現在国を含まない)に無い色リスト piNxtClr を作る" );

	/* iDepth までの隣接国色のソート用データ piColor を生成 */
		/* piInNeigh[ 0..iTmp1 ] までをソート */
		/* ソート済データを格納領域 piOtNeigh にコピー */
		memcpy( piOtNeigh, Sort1( iTmp1, piInNeigh ),
												iTmp1 * sizeof( int ) );

	/* 色決定済国のソート準備 */
	/* まず現状までに考慮した国番号は(現在国の国番号を含まない) */
		for( iLp1 = 0; iLp1 < iDepth; iLp1 ++ ){
			piInStat[ iLp1 ] = getStat( iLp1, ID );
		}
#ifdef	DEBUG
		_NOTRC_DMPD( "iDepth(<ELEVEN):現在国の深さ", iDepth );
		/* 現在国を含まない色決定済国番号リストのダンプ */
		for( iLp1 = 0; iLp1 < iDepth; iLp1 ++ ){
			sprintf(  pcMsg, "色決定済国番号:piInStat[%3d]=%3d",
											iLp1, piInStat[ iLp1 ] );
			_NOTRC_DUMP( pcMsg  );
		}
#endif
		/* piInStat[ 0..(iDepth) ] まで(現在国を含まない)をソート */
		/* piOtStat にはソート済色決定済国番号列が入る */
		memcpy( piOtStat, Sort1( iDepth, piInStat ),
										iDepth * sizeof( int ) );
	/* piInStat と piInNeigh の共通部分を求める */
	/* 現在国番号を含まない隣接国番号と色決定済国番号の共通部分を作る */
	/* piIntr[ 0..iDepth ] に設定 */
	/* ソート済データ piOtStat と piOtNeigh の共通部分を求める */
	/* 現在国を含まない隣接国(piOtNeigh)と色決定済国(piOtStat)の共通部分は */
		/* 共通部分には現在国は含む */
		iIntrNo = Match( piOtStat, iDepth, piOtNeigh, iTmp1, piIntr );
		_NOTRC_DUMP( "現在国と色決定済国隣接国の共通部分(piIntr[...])" );
		_NOTRC_DMPD( "その濃度は:iIntrNo", iIntrNo );
		/* piIntr[ 0..iIntrNo ] は隣接国番号と色決定国済番号の共通部分 */
		/* piIntr[ 0..iIntrNo ] は色が決定済の隣接国番号列 */
#ifdef	DEBUG
		_NOTRC_DUMP( "piIntr[ 0..iIntrNo ] は色が決定済の隣接国番号列" );
		_NOTRC_DMPD( "iIntrNo(<ELEVEN):色決定済隣接国数", iIntrNo );
		for( iLp1 = 0; iLp1 < iIntrNo; iLp1 ++ ){
			sprintf(  pcMsg, "色決定済隣接国番号:piIntr[%3d]=%d,色=%d",
					iLp1, piIntr[ iLp1 ], area[ piIntr[ iLp1 ] ].color );
			_NOTRC_DUMP( pcMsg  );
		}
#endif

	/* 色決定済み隣接国番号が piIntr[ 0..iIntrNo ] となる */
	/* 色決定済隣接国の色情報 piColor は */
	for( iLp1 = 0; iLp1 < iIntrNo; iLp1 ++ ){
		piColor[ iLp1 ] = area[ piIntr[ iLp1 ] ].color;
	}
	memcpy( piOtColor, Sort1( iIntrNo, piColor ),
								sizeof( int ) * iIntrNo );
#ifdef	DEBUG
	_NOTRC_DMPD( "iIntrNo(<ELEVEN)", iIntrNo );
	for( iLp1 = 0; iLp1 < iIntrNo; iLp1 ++ ){
		sprintf(  pcMsg,
		"色決定済隣接国国の色番号(現在国色番号含まず):piOtColor[%d]=%d",
						iLp1, piOtColor[ iLp1 ] );
		_NOTRC_DUMP( pcMsg  );
	}
#endif

	/* piCscTbl は piColor(<ELEVEN) の補集合となる歯抜けの集合 */
	/* このテーブルが現在国色を含む。現在国色は決定情報 */
	/* 先ずは格納変数の HighValue クリア */
	piHighVal( piNxtClr, maxclr );
	/* genCscTbl() で補集合(隣接国が含まない)を求める */
	iSz = genCsc( iIntrNo, piOtColor, piNxtClr, maxclr );
	_NOTRC_DMPD( "iSz(<maxclr)]", iSz );
#ifdef	DEBUG
	for( iLp1 = 0; iLp1 < iSz; iLp1 ++ ){
		sprintf(  pcMsg, "隣接国の未決定色番号:piNxtClr[%3d]=%d",
												iLp1, piNxtClr[ iLp1 ] );
		_NOTRC_DUMP( pcMsg  );
	}
#endif
	/* piNxtClr(固定領域) にはダブリのない一意の iSz 個の
						隣接国に無い色情報がある */
	_NOTRC_EXIT();
	return( iSz );
}

int		Neigh(
color_t	*area,
int		eleven,
int		iDepth,
int		*piNxtClr,
int		maxclr
){
	int		iLp1, iRtn, iTmp, iSz;

	_NOTRC_ENTR( "Neigh" );
	_NOTRC_DMPD( "eleven", eleven );
	_NOTRC_DMPD( "iDepth", iDepth );
	_NOTRC_DMPD( "maxclr", maxclr );
#if	0
	/* iTmp は現在国番号、iDepth の深さの iStat の情報 */
	iTmp = getStat( iDepth, ID );
	_NOTRC_DMPD( "現在国番号", iTmp );
#endif
	/* 隣接国に無い色リスト piCscTbl を作る。iSz は可能色数となる。 */
	iSz = NeighClrLst( area, eleven, iDepth, piNxtClr, maxclr );

#ifdef	DEBUG
	_NOTRC_DMPD( "iSz", iSz );
	for( iLoop1 = 0; iLoop1 < iSz; iLoop1 ++ ){
		sprintf( pcMsg, "piNxtClr[%d]:決定可能色=%d",
								iLoop1, piNxtClr[ iLoop1 ] );
		_NOTRC_DUMP( pcMsg );
	}
#endif
	/* 隣接国の色が現在国の色と異なるなら現在国の色は正しい */
	_NOTRC_DMPD( "iRtn=Neigh()", iSz );
	_NOTRC_EXIT();
	return( iSz );
}

void	Print(
color_t	*area,
int		iDepth
){
	int		iLp1, iRtn;
	char	pcBuf[ MAXBUFSZ ];
	char	pcTmp[ 10 ];

	_TRC_ENTR( "Print" );
	_TRC_DMPD( "iDepth", iDepth );

#if	0
	/* これは二重書きですが、*/
	/* 深さiLp1のIDの(Areaの)色は深さiLp1の状態テーブルの色となる。*/
	for( iLp1 = 0; iLp1 < iDepth; iLp1 ++ ){
		area[ getStat( iLp1, ID ) ].color = getStat( iLp1, CLR );
	}
#endif
	/* 隣接国との色重複点検 */
	_TRC_DMPD( "iDepth", iDepth );
	iRtn = NeiChk( area, iDepth );
	_TRC_DMPD( "iRtn", iRtn );
	_NOTRC_DMPD( "CLR2_ERROR", CLR2_ERROR );
	if( iRtn == CLR2_ERROR ){
		_TRC_DUMP( "---- No print ----" );
		_TRC_EXIT();
		return;
	}
	/* 正しいデータを出力 */
	*pcBuf = 0x00;
	_TRC_DUMP( "データ出力" );
	for( iLp1 = 0; iLp1 < iDepth; iLp1 ++ ){
#ifdef	DEBUG
		sprintf( pcMsg,
			"printf(Depth=%d,Color=%d)", iLp1, area[ iLp1 ].color );
		_TRC_DUMP( pcMsg );
#endif
		sprintf( pcTmp, "%02d,", area[ iLp1 ].color );
		strcat( pcBuf, pcTmp );
	}
	fprintf( pstFid, "%s\n", pcBuf );

	fflush( pstFid );

	_TRC_EXIT();
}

extern	void	setAllSt(
int		iDepth,	/* 処理中の現在国番号 */
int		iColor,	/* 現在国の色番号 */
int		iSt,	/* 現在の状態番号 */
color_t	*area
){
	int		iLp1;

	_NOTRC_ENTR( "setAllSt" );
	_NOTRC_DMPD( "iDepth", iDepth );
	_NOTRC_DMPD( "iColor", iColor );
	_NOTRC_DMPD( "iSt", iSt );
	/* 状態テーブルの設定 */
	setStat( iDepth, CLR, iColor );
	setStat( iDepth, STAT, iSt );
	area[ getStat( iDepth, ID ) ].color = iColor;
#ifdef	DEBUG
	_NOTRC_DMPD( "iColor", iColor );
	sprintf( pcMsg, "iDepth=%d:", iDepth );
	_NOTRC_DUMP( pcMsg );
	sprintf( pcMsg, "No,:CLR  ,ID   ,STAT ," );
	_NOTRC_DUMP( pcMsg );
	for( iLp1 = 0; iLp1 < ELEVEN; iLp1 ++ ){
		sprintf( pcMsg, "%3d:%5d,%5d,%5d,",
					iLp1,
					getStat( iLp1, CLR ),
					getStat( iLp1, ID ),
					getStat( iLp1, STAT ) );
	_NOTRC_DUMP( pcMsg );
	}
#endif

	_NOTRC_EXIT();
}

void	setStat(
int		iDepth,
int		iType,
int		iValue
){
	_NOTRC_ENTR( "setStat" );

	_NOTRC_DMPD( "Depth", iDepth );
#if	0
	iDepth --;
#endif
	_NOTRC_DMPD( "iDepth", iDepth );
	_NOTRC_DMPD( "Type", iType );
	_NOTRC_DMPD( "Value", iValue );

	iStat[ iDepth ][ iType ] = iValue;
	_NOTRC_EXIT();
}

int		getStat(
int		iDepth,
int		iType
){
	_NOTRC_ENTR( "getStat" );

	_NOTRC_DMPD( "iDepth", iDepth );
#if	0
	iDepth --;
#endif
	_NOTRC_DMPD( "iType", iType );
	_NOTRC_DMPD( "Value", iStat[ iDepth ][ iType ] );

	_NOTRC_EXIT();
	return( iStat[ iDepth ][ iType ] );
}

static	int		genCsc(
int		iSz,
int		*piInTbl,
int		*piCscTbl,
int		maxclr
){
	int		iLp1, iLp2, iLp3, iLp4, iOk;
	int		piClrTbl[ maxclr ], iPreClr;

	_NOTRC_ENTR( "genCsc" );
	_NOTRC_DUMP( "----------------------------------" );
	_NOTRC_DMPD( "iSz", iSz );
	_NOTRC_DMPD( "maxclr", maxclr );
	if( iSz == 0 ){
		/* 入力した色番号列が空集合 */
		for( iLp1 = 0; iLp1 < maxclr; iLp1 ++ ){
			piCscTbl[ iLp1 ] = iLp1;
		}
		_NOTRC_EXIT();
		return( maxclr );
	}
	else{
		/* 入力した色番号列が空集合では無い */
#ifdef	DEBUG
		_NOTRC_DMPD( "iSz:入力データ数", iSz );
		for( iLoop1 = 0; iLoop1 < iSz; iLoop1 ++ ){
			sprintf( pcMsg, "入力データ:piInTbl[%d]=%d",
										iLoop1, piInTbl[ iLoop1 ] );
			_NOTRC_DUMP( pcMsg );
		}
#endif
		/*
			piInTbl[ ... ] の重複を取り除く
		*/
		iLp1 = 0;
		iLp2 = 0;
		iLp3 = 0;
		iLp4 = 0;
		piClrTbl[ iLp3 ] = iPreClr = piInTbl[ iLp1 ];
		for( iLp1 = iLp3 = 1; iLp1 < iSz; iLp1 ++ ){
			if( piInTbl[ iLp1 ] != iPreClr ){
				piClrTbl[ iLp3 ] = iPreClr = piInTbl[ iLp1 ];
				iLp3 ++;
			}
		}
#ifdef	DEBUG
		_NOTRC_DMPD( "iLp3(=piInTblの有効で一意なデータ数)", iLp3 );
		for( iLoop1 = 0; iLoop1 < iLp3; iLoop1 ++ ){
			sprintf( pcMsg, "piClrTbl[%d]=%d",
									iLoop1, piClrTbl[ iLoop1 ] );
			_NOTRC_DUMP( pcMsg );
		}
#endif
		for( iLp1 = 0; iLp1 < maxclr; iLp1 ++ ){
			for( iLp2 = 0, iOk = 0; iLp2 < iLp3; iLp2 ++ ){
				if( piClrTbl[ iLp2 ] == iLp1 ){
					iOk = 1;
					break;
				}
			}
			if( iOk == 0 ){
				piCscTbl[ iLp4 ] = iLp1;
				iLp4 ++;
			}
		}
	}
#ifdef	DEBUG
	_NOTRC_DMPD( "iLp4(=piInTblに無い一意なデータ数)", iLp3 );
	for( iLoop1 = 0; iLoop1 < iLp4; iLoop1 ++ ){
		sprintf( pcMsg, "piCscTbl[%d]=%d",
								iLoop1, piCscTbl[ iLoop1 ] );
		_NOTRC_DUMP( pcMsg );
	}
#endif

	_NOTRC_EXIT();
	return( iLp4 );
}

static	int		 Match(
int		*piInDt1,
int		iSz1,
int		*piInDt2,
int		iSz2,
int		*piOtDt
){
	int		iSz;
	int		iLp1, iLp2, iLp3;
	int		piOtData[ ( iSz1 < iSz2 ) ? iSz1 : iSz2 ];

	_NOTRC_ENTR( "Match" );
	_NOTRC_DMPD( "iSz1", iSz1 );
	_NOTRC_DMPD( "iSz2", iSz2 );
#ifdef	DEBUG
	_NOTRC_DUMP( "----------------" );
	_NOTRC_DMPD( "iSz1", iSz1 );
	for( iLoop1 = 0; iLoop1 < iSz1; iLoop1 ++ ){
		sprintf( pcMsg, "piInDt1[%2d]=%d", iLoop1, piInDt1[ iLoop1 ] );
		_NOTRC_DUMP( pcMsg );
	}
	_NOTRC_DUMP( "----------------" );
	_NOTRC_DMPD( "iSz2", iSz2 );
	for( iLoop1 = 0; iLoop1 < iSz2; iLoop1 ++ ){
		sprintf( pcMsg, "piInDt2[%2d]=%d", iLoop1, piInDt2[ iLoop1 ] );
		_NOTRC_DUMP( pcMsg );
	}
#endif
	iLp1 = iLp2 = iLp3 = 0;
	while( iLp1 < iSz1 || iLp2 < iSz2 ){
		if( piInDt1[ iLp1 ] == 0x7ffffff
				&& piInDt2[ iLp2 ] == 0x7fffffff ){
			break;
		}
		if( piInDt1[ iLp1 ] < piInDt2[ iLp2 ] ){		
			iLp1 ++;
		}
		else if( piInDt1[ iLp1 ] == piInDt2[ iLp2 ] ){
			piOtData[ iLp3 ] = piInDt1[ iLp1 ];
			iLp1 ++;
			iLp2 ++;
			iLp3 ++;
		}
		else{
			iLp2 ++;
		}
	}
	memcpy( piOtDt, piOtData, sizeof( int ) * iLp3 );

#ifdef	DEBUG
	_NOTRC_DUMP( "----------------" );
	_NOTRC_DMPD( "iLp3", iLp3 );
	for( iLoop1 = 0; iLoop1 < iLp3; iLoop1 ++ ){
		sprintf( pcMsg, "piOtDt[%2d]=%d", iLoop1, piOtDt[ iLoop1 ] );
		_NOTRC_DUMP( pcMsg );
	}
#endif
	_NOTRC_EXIT();
	return( iLp3 );
}

int		NeiChk(
color_t	*area,
int		eleven
){
	int		iLp1, iLp2, iRtn;

	_TRC_ENTR( "NeiChk" );
	_TRC_DMPD( "eleven", eleven );

	iRtn = CLR2_NORMAL;
	for( iLp1 = 0; iLp1 < eleven; iLp1 ++ ){
		if( area[ iLp1 ].color == -1 ){
			iRtn = CLR2_ERROR;
			_TRC_DMPD( "iRtn", iRtn );
			_TRC_EXIT();
			return( iRtn );
		}
	}
	
	iRtn = CLR2_NORMAL;
	for( iLp1 = 0; iLp1 < eleven; iLp1 ++ ){
#if	0
		for( iLp2 = 0; iLp2 < area[ iLp1 ].no; iLp2 ++ ){
			if( area[ area[ iLp1 ].neib[ iLp2 ] ].color
					== -1 ){
				iRtn = CLR2_ERROR;
				_TRC_DMPD( "iRtn", iRtn );
				_TRC_EXIT();
				return( iRtn );
			}
		}
#endif
		for( iLp2 = 0; iLp2 < area[ iLp1 ].no; iLp2 ++ ){
			_TRC_DMPD( "--->no", area[ iLp1 ].no );
			if( area[ iLp1 ].color
					== area[ area[ iLp1 ].neib[ iLp2 ] ].color ){
#ifdef	DEBUG
sprintf( pcMsg,
"area[%d].color(%d)==area[area[%d].neib[%d]=(%d)].color(%d)",
iLp1,area[iLp1].color,
iLp1,iLp2,area[iLp1].neib[iLp2],area[area[iLp1].neib[iLp2]].color );
				_TRC_DUMP( pcMsg );
#endif
				iRtn = CLR2_ERROR;
				_TRC_DMPD( "iRtn", iRtn );
				_TRC_EXIT();
				return( iRtn );
			}
		}
	}
	_TRC_DMPD( "iRtn", iRtn );

	_TRC_EXIT();
	return( iRtn );
}

#if	0
int		*getCscTbl(
void
){
	return( piCscTbl );
}
#endif

static	void	piHighVal(
int		*a,
int		b
){
	int		iLp1;

	for( iLp1 = 0; iLp1 < b; iLp1 ++ ){
		a[ iLp1 ] = 0x7fffffff;
	}
}

void	setFid(
FILE	*pstfid
){
	pstFid = pstfid;
}
