/*
	(c)Copyright	All rights reserved.
		K.Masuda	2023.12.30
			< Tran.c >
*/

#include	"CryptOneX.h"

#define	I2(a,b)	( a ) * 2 + ( b )
	
static	int		GetNewNo( int *, int, int );

int		main(
int		iArgc,
char	*pcArgv[]
){
	int		iLp1, iLMax;
	char	pcFrBuf[ 60 ][ 256 ];
	char	pcToBuf[ 256 ];
	char	pcNo1[ 4 ], pcNo2[ 4 ];
	int		iNo[ 60 * 2 ];
	char	*pcTmp;
	char	*pcArea0, *pcArea1, *pcArea2, *pcArea3;
	int		iNewNo;
	char	pcTmpBuf[ 256 ];

	_TRC_INIT( "Tran" );
	_TRC_ENTR( "main" );

	/*
		地域データを読み込む
	*/
	for( iLp1 = 0; fgets( pcFrBuf[ iLp1 ], 256, stdin ) != NULL; iLp1 ++ ){
		pcFrBuf[ iLp1 ][ strlen( pcFrBuf[ iLp1 ] ) - 1 ] = 0x00;
		_TRC_DMPS( "pcFrBuf", pcFrBuf[ iLp1 ] );
	}
	iLMax = iLp1;

	/*
		バッファの１行目から最終行まで繰返す
	*/
	for( iLp1 = 0; iLp1 < iLMax; iLp1 ++ ){
		strncpy( pcNo1, pcFrBuf[ iLp1 ], 4 );
		strncpy( pcNo2, &pcFrBuf[ iLp1 ][ 4 ], 4 );
		pcTmp = strchr( pcNo1, ',' );	
		pcTmp = 0x00;
		pcTmp = strchr( pcNo2, ',' );	
		pcTmp = 0x00;

		iNo[ I2( iLp1, 0 ) ] = atoi( pcNo1 );
		iNo[ I2( iLp1, 1 ) ] = atoi( pcNo2 ); }

		_TRC_DMPS( "pcNo1", pcNo1 );
		_TRC_DMPS( "pcNo2", pcNo2 );
	/*
		バッファの各行の隣接情報を変換する
	*/
	for( iLp1 = 0; iLp1 < iLMax; iLp1 ++ ){
		/* 出力バッファNULLクリア */
		memset( pcToBuf, 0x00, 256 );
		/* 新エリア番号 */
		pcArea0 = pcFrBuf[ iLp1 ];
		pcTmp = strchr( pcFrBuf[ iLp1 ], ',' );
		*pcTmp = 0x00;
		pcTmp ++;
		/* 旧エリア番号 */
		pcArea1 = pcTmp;
		pcTmp = strchr( pcArea1, ',' );
		*pcTmp = 0X00;
		pcTmp ++;

		_TRC_DMPS( "pcArea0", pcArea0 );
		_TRC_DMPS( "pcArea1", pcArea1 );

		/* 国名 */
		pcArea2 = pcTmp;
		pcTmp = strchr( pcArea2, ',' );
		pcTmp ++;
		pcTmp = strchr( pcTmp, ',' );
		*pcTmp = 0x00;
		pcTmp ++;

		_TRC_DMPS( "pcArea2", pcArea2 );

		/* 新隣接国情報の出力（番号、国名、地域名） */
		sprintf( pcTmpBuf, "%s,%s,", pcArea0, pcArea2 );
		strcat( pcToBuf, pcTmpBuf );
		while( 1 ){
			/* 隣接国番号 */
			pcArea3 = pcTmp;
			pcTmp = strchr( pcTmp, ',' );
			if( !pcTmp ){
				break;
			}
			*pcTmp = 0x00;
			pcTmp ++;
			/* 旧隣接国番号から新隣接国番号を取得 */
			_TRC_DMPS( "pcArea3", pcArea3 );
			iNewNo = GetNewNo( iNo, atoi( pcArea3 ), iLMax );
#ifdef	UNIFY
			if( iNewNo != -1 ){
				sprintf( pcTmpBuf, "%d,", iNewNo );
				strcat( pcToBuf, pcTmpBuf );
			}
#else
			sprintf( pcTmpBuf, "%d,", iNewNo );
			strcat( pcToBuf, pcTmpBuf );
#endif
		}
		sprintf( pcTmpBuf, "\n" );
		strcat( pcToBuf, pcTmpBuf );
		printf( "%s", pcToBuf );
	}
	_TRC_EXIT();
	_TRC_TERM();

	/* 終了 */
	exit( 0 );
}

static	int		GetNewNo(
int		*iNo,
int		iNum,
int		iLMax
) {
	int		iLp1;

	_TRC_ENTR( "GetNewNo" );
	_TRC_DMPD( "iNum", iNum );

	for( iLp1 = 0; iLp1 < iLMax; iLp1 ++ ){
		if( iNum == iNo[ I2( iLp1, 1 ) ] ){
			_TRC_DMPD( "iNo", iNo[ I2( iLp1 ,1 ) ] );
			_TRC_DMPD( "iNo", iNo[ I2( iLp1 ,0 ) ] );
			_TRC_EXIT();
			return( iNo[ I2( iLp1 ,0 ) ] );
		}
	}
	_TRC_EXIT();
	return( -1 );
}
