/*
	(c)Copyright	All rights reserved.
		K.Masuda	2022.06.18
			< Add.c >
*/

#include	"Calc.h"

static	char	pcRslt[ MAXDIGITSZ ];

char	*ZAdd(
char	*pcOp1,
char	*pcOp2
){
	char	pcR[ MAXDIGITSZ ];

	_TRC_ENTR( "ZAdd" );

	if( pcOp1[ 0 ] == '-' ){
		if( pcOp2[ 0 ] == '-' ){
			strcpy( &pcR[ 1 ], Add( &pcOp1[ 1 ], &pcOp2[ 1 ] ) );
			pcR[ 0 ] = '-';
			strcpy( pcRslt, pcR );
		}
		else{
			strcpy( pcRslt, Sub( pcOp2, &pcOp1[ 1 ] ) );
		}
	}
	else{
		if( pcOp2[ 0 ] == '-' ){
			strcpy( pcRslt, Sub( pcOp1, &pcOp2[ 1 ] ) );
		}
		else{
			Add( pcOp1, pcOp2 );
		}
	}

	_TRC_EXIT();
	return( pcRslt );
}

char	*Add(
char	*pcOp1,
char	*pcOp2
){
	int		iLen1, iLen2, iLen3;
	int		iLp1, iOpLen, iRsltL;;
	char	pcRslt1[ MAXDIGITSZ ];
	int		iLen;

	_TRC_ENTR( "Add" );

	_TRC_DMPS( "pcOp1", pcOp1 );
	_TRC_DMPS( "pcOp2", pcOp2 );

	iLen1 = strlen( pcOp1 );
	iLen2 = strlen( pcOp2 );
	iOpLen = ( iLen1 > iLen2 ) ? iLen1 : iLen2;

	if( iLen1 > iLen2 ){
		strcpy( pcRslt1, ADD( pcOp1, iLen1, pcOp2, iLen2 ) );	
	}
	else{
		strcpy( pcRslt1, ADD( pcOp2, iLen2, pcOp1, iLen1 ) );	
	}
	_NOTRC_DMPS( "pcRslt1", pcRslt1 );
#if	1
	for( iLp1 = 0; iLp1 < ( iLen = strlen( pcRslt1 ) ); iLp1 ++ ){
		_NOTRC_DMPD( "iLp1", iLp1 );
		_NOTRC_DMPC( "pcRslt[iLp1]", pcRslt[ iLp1 ] );
		if( pcRslt1[ iLp1 ] == '0' ){
			if( iLp1 == iLen - 1 ){
				strcpy( pcRslt, &pcRslt1[ iLp1 ] );
				break;
			}
			else{
				continue;
			}
		}
		else{
			_NOTRC_DMPD( "iLp1", iLp1 );
			strcpy( pcRslt, &pcRslt1[ iLp1 ] );
			_NOTRC_DMPS( "pcRslt", pcRslt );
			break;
		}
	}
#endif
	_TRC_DMPS( "pcRslt", pcRslt );

	_TRC_EXIT();
	return( pcRslt );
}

char	*ADD(
char	*pcOp1,
int		iLen1,
char	*pcOp2,
int		iLen2
){
	int		iLp1;
	int		iCarry;

	_TRC_ENTR( "ADD" );

	_TRC_DMPS( "pcOp1", pcOp1 );
	_TRC_DMPS( "pcOp2", pcOp2 );
	_TRC_DMPD( "iLen1", iLen1 );
	_TRC_DMPD( "iLen2", iLen2 );
	memset( pcRslt, 0x00, MAXDIGITSZ );
	memset( pcRslt, '0', iLen1 + 1 );
	for( iLp1 = 0; iLp1 < iLen1; iLp1 ++ ){
		iCarry = 0;
		_NOTRC_DUMP( "----- Result1" );
		if( iLp1 < iLen2 ){
			iCarry = pcOp1[ iLen1 - iLp1 - 1 ]
							+ pcOp2[ iLen2 - iLp1 - 1 ]
							+ pcRslt[ iLen1 - iLp1 ]
							- 3 * '0';
			_NOTRC_DMPC( "pcOp1[iLen1.-1]", pcOp1[ iLen1 - iLp1 - 1 ] );
			_NOTRC_DMPC( "pcOp2[iLen2.-1]", pcOp2[ iLen2 - iLp1 - 1 ] );
		}
		else{
			iCarry = pcOp1[ iLen1 - iLp1 - 1 ]
						+ pcRslt[ iLen1 - iLp1 ]
						- 2 * '0';
			_NOTRC_DMPC( "pcOp1[iLen1.-1]", pcOp1[ iLen1 - iLp1 - 1 ] );
		}
		_NOTRC_DMPD( "iLen1-iLp1", iLen1 - iLp1 );
		pcRslt[ iLen1 - iLp1     ] = iCarry % BASE10 + '0';
		pcRslt[ iLen1 - iLp1 - 1 ] = iCarry / BASE10 + '0';
		_NOTRC_DMPD( "iCarry", iCarry );
		_NOTRC_DMPC( "pcRslt[.+0]", pcRslt[ iLen1 - iLp1     ] );
		_NOTRC_DMPDX( ">pcRslt[.+0]", pcRslt[ iLen1 - iLp1     ] );
		_NOTRC_DMPC( "pcRslt[.-iLp1-1]", pcRslt[ iLen1 - iLp1 - 1 ] );
		_NOTRC_DMPD( "iLen1-iLp1", iLen1 - iLp1 );
		_NOTRC_DMPD( "iLp1", iLp1 );
		_NOTRC_DMPC( "pcRslt[.+4]", pcRslt[ iLen1 - iLp1 + 4 ] );
		_NOTRC_DMPC( "pcRslt[.+3]", pcRslt[ iLen1 - iLp1 + 3 ] );
		_NOTRC_DMPC( "pcRslt[.+2]", pcRslt[ iLen1 - iLp1 + 2 ] );
		_NOTRC_DMPC( "pcRslt[.+1]", pcRslt[ iLen1 - iLp1 + 1 ] );
		_NOTRC_DMPC( "pcRslt[.+0]", pcRslt[ iLen1 - iLp1 ] );
		_NOTRC_DMPDX( ">pcRslt[.+0]", pcRslt[ iLen1 - iLp1 ] );
		_NOTRC_DMPC( "pcRslt[.-1]", pcRslt[ iLen1 - iLp1 - 1 ] );
		_NOTRC_DMPDX( ">pcRslt[-1]", pcRslt[ iLen1 - iLp1  - 1 ] );
	}
	_NOTRC_DUMP( "----- Result2" );
	_NOTRC_DMPC( "pcRslt[.+0]", pcRslt[ 0 ] );
#if	0
	_NOTRC_DMPD( "pcRslt[.+0]", pcRslt[ 0 ] );
	_NOTRC_DMPDX( "pcRslt[.+0]", pcRslt[ 0 ] );
	pcRslt[ 0 ] += '0';
	_NOTRC_DMPC( "pcRslt[.+0]", pcRslt[ 0 ] );
#endif
	_NOTRC_DMPD( "iLen1-iLp1-1", iLen1 - iLp1 - 1 );
	_NOTRC_DMPD( "iLen1", iLen1 );
	_NOTRC_DMPD( "iLp1", iLp1 );
	_NOTRC_DMPC( "pcRslt[.+4]", pcRslt[ 4 ] );
	_NOTRC_DMPC( "pcRslt[.+3]", pcRslt[ 3 ] );
	_NOTRC_DMPC( "pcRslt[.+2]", pcRslt[ 2 ] );
	_NOTRC_DMPC( "pcRslt[.+1]", pcRslt[ 1 ] );
	_NOTRC_DMPC( "pcRslt[.+0]", pcRslt[ 0 ] );
	_NOTRC_DMPS( "pcOp1", pcOp1 );
	_NOTRC_DMPS( "pcOp2", pcOp2 );
	_NOTRC_DMPD( "iLen1	", iLen1 );
	_NOTRC_DMPD( "iLen2	", iLen2 );
	_NOTRC_DMPD( "iLenRslt", strlen( pcRslt ) );
	_NOTRC_DMPS( "pcRslt", pcRslt );
	
	_TRC_EXIT();
	return( pcRslt );
}
