/*
	(c)Copyright	All rights reserved.
		K.Masuda	2022.06.18
			< Div.c >
*/

#include	"Calc.h"

static	Result	stRslt;
static	int		iLpQuot = 0;

Result	*ZDiv(
char	*pcOp1,
char	*pcOp2
){
	Result	stR;

	_TRC_ENTR( "ZDiv" );

	if( pcOp1[ 0 ] == '-' ){
		if( pcOp2[ 0 ] == '-' ){
			memcpy( &stR, Div( &pcOp1[ 1 ], &pcOp2[ 1 ] ),
												sizeof( Result ) );
			strcpy( stRslt.pcQuot, stR.pcQuot );
			if( strcmp( stR.pcRsdu, "0" ) != 0 ){
				strcpy( stRslt.pcRsdu, "-" );
				strcat( &stRslt.pcRsdu[ 0 ], stR.pcRsdu );
			}
		}
		else{
			memcpy( &stR, Div( &pcOp1[ 1 ], pcOp2 ),
												sizeof( Result ) );
			strcpy( stRslt.pcQuot, "-" );
			strcat( stRslt.pcQuot, stR.pcQuot );
			if( strcmp( stR.pcRsdu, "0" ) != 0 ){
				strcpy( stRslt.pcRsdu, "-" );
				strcat( &stRslt.pcRsdu[ 0 ], stR.pcRsdu );
			}
		}
	}
	else{
		if( pcOp2[ 0 ] == '-' ){
			memcpy( &stR, Div( pcOp1, &pcOp2[ 1 ] ),
												sizeof( Result ) );
			strcpy( stRslt.pcQuot, "-" );
			strcat( stRslt.pcQuot, stR.pcQuot );
			strcpy( stRslt.pcRsdu, stR.pcRsdu );
		}
		else{
			memcpy( &stR, Div( pcOp1, pcOp2 ),
												sizeof( Result ) );
			memcpy( &stRslt, &stR, sizeof( Result ) );
		}
	}
	
	_TRC_EXIT();
	return( &stRslt );
}

Result	*Div(
char	*pcOpe1,
char	*pcOpe2
){
	char	pcOp1[ MAXDIGITSZ ];
	char	pcOp2[ MAXDIGITSZ ];
	int		iLen1, iLen2;
	int		iLp1;
	int		iLen;

	_TRC_ENTR( "Div" );

	strcpy( pcOp1, pcOpe1 );
	strcpy( pcOp2, pcOpe2 );
	_TRC_DMPS( "pcOp1", pcOp1 );
	_TRC_DMPS( "pcOp2", pcOp2 );

	memset( &stRslt, 0x00, sizeof( Result ) );

	iLen1 = strlen( pcOp1 );
	iLen2 = strlen( pcOp2 );

	if( strcmp( pcOp2, "0" ) == 0 ){
		fprintf( stderr, "0 divide\n" );
		_TRC_EXIT();
		_TRC_TERM();
		exit( 1 );
	}
	else if( strcmp( "0", pcOp1 ) == 0 ){
		strcpy( stRslt.pcQuot, "0" );
		strcpy( stRslt.pcRsdu, "0" );
		_TRC_EXIT();
		return( &stRslt );
	}
	else if( iLen1 < iLen2 ){
		strcpy( stRslt.pcQuot, "0" );
		strcpy( stRslt.pcRsdu, pcOp1 );
		_TRC_EXIT();
		return( &stRslt );
	}
	else if( iLen1 == iLen2 ){
		if( strcmp( pcOp1, pcOp2 ) < 0 ){
			strcpy( stRslt.pcQuot, "0" );
			strcpy( stRslt.pcRsdu, pcOp1 );
			_TRC_EXIT();
			return( &stRslt );
		}
		else if( strcmp( pcOp1, pcOp2 ) == 0 ){
			strcpy( stRslt.pcQuot, "1" );
			strcpy( stRslt.pcRsdu, "0" );
			_TRC_EXIT();
			return( &stRslt );
		}
		else{
			for( iLp1 = 0; *pcOp1 != '-'; iLp1 ++ ){
				strcpy( pcOp1, Sub( pcOp1, pcOp2 ) );
			}
			stRslt.pcQuot[ 0 ] = iLp1 - 1 + '0';
			strcpy( stRslt.pcRsdu, Sub( pcOp2, &pcOp1[ 1 ] ) );
		}
	}
	else{
		memcpy( &stRslt, DIV( pcOp1, iLen1, pcOp2, iLen2 ),
											sizeof( Result ) );	
	}

#if	1
	for( iLp1 = 0; iLp1 < ( iLen = strlen( stRslt.pcQuot ) ); iLp1 ++ ){
		if( stRslt.pcQuot[ iLp1 ] == '0' ){
			if( iLp1 == 0 ){
				strcpy( stRslt.pcQuot, &stRslt.pcQuot[ iLp1 ] );
				break;
			}
			else{
				continue;
			}
		}
		else{
			memcpy( stRslt.pcQuot, &stRslt.pcQuot[ iLp1 ],
								strlen( &stRslt.pcQuot[ iLp1 ] ) );
			break;
		}
	}
#endif
	_TRC_DMPS( "Quotient", stRslt.pcQuot );
	_TRC_DMPS( "Residue", stRslt.pcRsdu );

	_TRC_EXIT();
	return( &stRslt );
}

Result	*DIV(
char	*pcOp1,
int		iLen1,
char	*pcOp2,
int		iLen2
){
	int		iLp1, iLp2, iCond;
	char	pcOp3[ MAXDIGITSZ ];

	_TRC_ENTR( "DIV" );

	_TRC_DMPS( "pcOp1", pcOp1 );
	_TRC_DMPS( "pcOp2", pcOp2 );
	_TRC_DMPD( "iLen1", iLen1 );
	_TRC_DMPD( "iLen2", iLen2 );

	memset( &stRslt, 0x00, sizeof( Result ) );
	strcpy( pcOp3, pcOp2 );
	Shift( pcOp3, iLen1 - iLen2 );
	_TRC_DMPS( "pcOp3", pcOp3 );
	for( iLp1 = 0; iLp1 < iLen1 - iLen2 + 1; iLp1 ++ ){
		if( strlen( pcOp1 ) == strlen( pcOp3 ) ){
			if( strcmp( pcOp1, pcOp3 ) < 0 ){
				if( iLpQuot != 0 ){
					stRslt.pcQuot[ iLpQuot ] = '0';
					strcpy( stRslt.pcRsdu, pcOp1 );
					iLpQuot ++;
				}
				Shift( pcOp3, -1 );
				continue;
			}
		}
		_TRC_DMPD( "----- iLp1 -----", iLp1 );
		_NOTRC_DMPD( "iLpQuot", iLpQuot );
		_TRC_DMPD( "iLen1 - iLen2 + 1", iLen1 - iLen2 + 1 );
		_TRC_DUMP( "--- 1::strcmp( pcOp1, pcOp3 )" );
		_TRC_DMPS( "pcOp1", pcOp1 );
		_TRC_DMPS( "pcOp3", pcOp3 );
		_TRC_DUMP( "--- 2::strcmp( pcOp1, pcOp3 )" );
		_NOTRC_DMPS( "pcOp1", pcOp1 );
		_NOTRC_DMPS( "pcOp3", pcOp3 );
		for( iLp2 = 0; *pcOp1 != '-'; iLp2 ++ ){
			_TRC_DUMP( "--- 3::strcmp( pcOp1, pcOp3 )" );
			strcpy( pcOp1, Sub( pcOp1, pcOp3 ) );
			_TRC_DMPS( "pcOp1", pcOp1 );
		}
		_NOTRC_DMPS( "pcOp1", pcOp1 );
		_NOTRC_DMPS( "&pcOp1[1]", &pcOp1[ 1 ] );
		strcpy( pcOp1, Sub( pcOp3, &pcOp1[ 1 ] ) );
		_TRC_DUMP( "--- 4::strcmp( pcOp1, pcOp3 )" );
		stRslt.pcQuot[ iLpQuot ] = iLp2 - 1 + '0';
		strcpy( stRslt.pcRsdu, pcOp1 );
		_NOTRC_DMPD( "iLp2", iLp2 );
		_NOTRC_DMPS( "pcOp1", pcOp1 );
		_TRC_DMPS( "Quot", stRslt.pcQuot );
		_TRC_DMPS( "Rsdu", stRslt.pcRsdu );
		iLpQuot ++;
		_TRC_DMPS( "--- pcOp3", pcOp3 );
		if( strcmp( pcOp3, pcOp2 ) == 0 ){
			break;
		}
		Shift( pcOp3, -1 );
		_TRC_DMPS( "--- pcOp3", pcOp3 );
		_NOTRC_DMPS( "pcOp1", pcOp1 );
	}

	_TRC_EXIT();
	return( &stRslt );
}
