/*
	(c)Copyright	All rights reserved.
		K.Masuda	2022.06.22
			< Mul.c >
*/

#include	"Calc.h"

static	char	pcRslt[ MAXDIGITSZ ];

char	*ZMul(
char	*pcOp1,
char	*pcOp2
){
	char	pcR[ MAXDIGITSZ ];

	_TRC_ENTR( "ZMul" );

	if( pcOp1[ 0 ] == '-' ){
		if( pcOp2[ 0 ] == '-' ){
			Mul( &pcOp1[ 1 ], &pcOp2[ 1 ] );
		}
		else{
			strcpy( pcR, "-" );
			strcat( pcR, Mul( &pcOp1[ 1 ], pcOp2 ) );
			strcpy( pcRslt, pcR );
		}
	}
	else{
		if( pcOp2[ 0 ] == '-' ){
			strcpy( pcR, "-" );
			strcat( pcR, Mul( pcOp1, &pcOp2[ 1 ] ) );
			strcpy( pcRslt, pcR );
		}
		else{
			Mul( pcOp1, pcOp2 );
		}
	}

	_TRC_EXIT();
	return( pcRslt );
}

		
char	*Mul(
char	*pcOpe1,
char	*pcOpe2
){
	char	pcOp1[ MAXDIGITSZ ];
	char	pcOp2[ MAXDIGITSZ ];
	int		iLen1, iLen2, iLen3;
	int		iLp1, iOpLen, iRsltL;;
	char	pcRslt1[ MAXDIGITSZ ];
	int		iLen;

	_TRC_ENTR( "Mul" );

	strcpy( pcOp1, pcOpe1 );
	strcpy( pcOp2, pcOpe2 );

	_TRC_DMPS( "pcOp1", pcOp1 );
	_TRC_DMPS( "pcOp2", pcOp2 );

	iLen1 = strlen( pcOp1 );
	iLen2 = strlen( pcOp2 );
	iOpLen = ( iLen1 > iLen2 ) ? iLen1 : iLen2;

	if( iLen1 > iLen2 ){
		strcpy( pcRslt1, MUL( pcOp1, iLen1, pcOp2, iLen2 ) );	
	}
	else if( iLen1 == iLen2 ){
		if( strcmp( pcOp1, pcOp2 ) < 0 ){
			strcpy( pcRslt1, MUL( pcOp2, iLen2, pcOp1, iLen1 ) );	
		}
		else{
			strcpy( pcRslt1, MUL( pcOp1, iLen1, pcOp2, iLen2 ) );	
		}
	}
	else{
		strcpy( pcRslt1, MUL( pcOp2, iLen2, pcOp1, iLen1 ) );	
	}
	_TRC_DMPS( "pcRslt1", pcRslt1 );
#if	1
	for( iLp1 = 0; iLp1 < ( iLen = strlen( pcRslt1 ) ); iLp1 ++ ){
		_NOTRC_DMPD( "iLp1", iLp1 );
		_NOTRC_DMPC( "pcRslt[iLp1]", pcRslt[ iLp1 ] );
		if( pcRslt1[ iLp1 ] == '0' ){
			if( iLp1 == iLen - 1 ){
				strcpy( pcRslt, &pcRslt1[ iLp1 ] );
				break;
			}
			else{
				continue;
			}
		}
		else{
			_NOTRC_DMPD( "iLp1", iLp1 );
			strcpy( pcRslt, &pcRslt1[ iLp1 ] );
			_NOTRC_DMPS( "pcRslt", pcRslt );
			break;
		}
	}
#endif
	_TRC_DMPS( "pcRslt", pcRslt );

	_TRC_EXIT();
	return( pcRslt );
}

char	*MUL(
char	*pcOp1,
int		iLen1,
char	*pcOp2,
int		iLen2
){
	int		iLp1, iLp2;
	char	pcOp3[ MAXDIGITSZ ];

	_TRC_ENTR( "MUL" );

	_TRC_DMPS( "pcOp1", pcOp1 );
	_TRC_DMPS( "pcOp2", pcOp2 );
	_TRC_DMPD( "iLen1", iLen1 );
	_TRC_DMPD( "iLen2", iLen2 );
	memset( pcOp3, 0x00, MAXDIGITSZ );
	memset( pcOp3, '0', 1 );
	for( iLp1 = 0; iLp1 < iLen2; iLp1 ++ ){
		for( iLp2 = 0; iLp2 < pcOp2[ iLen2 - iLp1 - 1 ] - '0'; iLp2 ++ ){
			strcpy( pcOp3, Add( pcOp3, pcOp1 ) );
		}
		_TRC_DMPS( "pcOp3", pcOp3 );
		iLen1 = Shift( pcOp1, 1 );
	}
	strcpy( pcRslt, pcOp3 );
		_TRC_DMPS( "pcRslt", pcRslt );
	
	_TRC_EXIT();
	return( pcRslt );
}
