/*
	(c)Copyright	All rights reserved.
		K.Masuda	2017.01.22
		and Shirhill family
			<<Nukari.c>>
*/
/*
	(c)Copyright	All rights reserved.
		K.Masuda	2016.01.18
					2019.02.17
	   k.masuda.52431@gmailcom


		and Shirhill family
		and Apple & Microsoft
			  and Bell.
*/
/*
	(c)Copyright	All rights reserved.
               <<CryptOneX>>
            K.Masuda & Shirhill
             Apple & Microsoft
                 Borland
               Oracle & IBM
             Bell & BSD & MIT
                  NORAD.

                 2020.04
                 2022.03
*/

#include	"CryptOneX.h"

static	int		x, y, gcd;

static	int		euclide( int, int *, int, int * );

int		main(
int		iArgc,
char	*pcArgv[]
){
	int		a, b;

	if( iArgc < 3 ){
		printf( "Euclide <num1> <num2>\n" );
		exit( 1 );
	}

	_NOTRC_INIT( "Euclide" );
	_NOTRC_ENTR( "main" );

	a = atoi( pcArgv[ 1 ] );
	b = atoi( pcArgv[ 2 ] );
	_NOTRC_DMPD( "a", a );
	_NOTRC_DMPD( "b", b );

	printf( "%d = %d * ( %d ) + %d * ( %d )\n",
						euclide( a, &x, b, &y ), a, x, b, y );
	_NOTRC_DMPD( "x", x );
	_NOTRC_DMPD( "y", y );

	_NOTRC_EXIT();
	_NOTRC_TERM();

	exit( 0 );
}

static	int		euclide(
int		a,
int		*pix,
int		b,
int		*piy
){
	int		q, r, w;

	_NOTRC_ENTR( "euclide" );
	q	= a / b;
	r	= a % b;
	_NOTRC_DMPD( "a", a );
	_NOTRC_DMPD( "b", b );
	_NOTRC_DMPD( "q", q );
	_NOTRC_DMPD( "r", r );
	if( r == 0 ){
		*pix	= 0;
		*piy	= 1;
		gcd		= b;
	}
	else{
		gcd = euclide( b, pix, r, piy );
		_NOTRC_DMPD( "x", *pix );
		_NOTRC_DMPD( "y", *piy );
		w = *pix;
		*pix = *piy;
		*piy = w + *piy * ( -q );
		_NOTRC_DMPD( "w", w );
		_NOTRC_DMPD( "x", *pix );
		_NOTRC_DMPD( "y", *piy );
	}
	_NOTRC_EXIT();
	return( gcd );
}
